import { DoCheck, EmbeddedViewRef, OnDestroy, OnInit, Renderer2, TemplateRef, ViewContainerRef } from '@angular/core';
import { StickyConfig } from './sticky-config';
export declare class StickyDirective implements OnInit, OnDestroy, DoCheck {
    protected readonly container: ViewContainerRef;
    protected readonly template: TemplateRef<HTMLElement>;
    protected readonly document: any;
    protected readonly renderer: Renderer2;
    protected get stickyStyle(): CSSStyleDeclaration;
    protected get fixedStyle(): CSSStyleDeclaration;
    protected get fixedClientRect(): ClientRect;
    protected get stickyClientRect(): ClientRect;
    protected get verticalOffset(): number;
    protected get horizontalOffset(): number;
    private get stickyClass();
    config: StickyConfig;
    protected fixed: EmbeddedViewRef<HTMLElement>;
    protected sticky: EmbeddedViewRef<HTMLElement>;
    private onScrollEventListener;
    constructor(container: ViewContainerRef, template: TemplateRef<HTMLElement>, document: any, renderer: Renderer2);
    ngOnInit(): void;
    ngOnDestroy(): void;
    ngDoCheck(): void;
    private isSizeAndPositionValid;
    private recreateElements;
    protected initializeStickyStyles(): void;
    private shouldShowSticky;
    private shouldHideSticky;
    private showSticky;
    private hideSticky;
    private onScroll;
    protected recalculateStickyStyles(): void;
}
